#! /bin/sh
#
#   mainmenu.sh -- CD-ROMǥᥤ˥塼
#
#	0.0: Jun. 20, 2004 by Dai ISHIJIMA (for wpout03)
#	0.1: Jul. 11  2004 (for wpout04)
#	0.2: Jun. 23  2005 (for wpout05)
#	0.3: Jul.  8  2005 (for wpout06)
#	0.4: Aug.  5, 2006 (for wpout07)
#	0.5: Dec. 21, 2006 (erase MBR)
#	0.6: Feb. 10, 2007 (Ͽ for wpout08)
#	0.7: Feb. 15, 2007 (󥿡Ĺк)
#	0.8: Feb. 18, 2007 (˥塼ν֤ѹ)
#	0.9: Sep. 12, 2007 (wpout09, FreeBSD 6.2R)
#	1.0: Sep. 17, 2007 (shutdownβ)
#	1.1: Oct.  6, 2007 (expr(1) POSIXб)
#	1.2: Feb. 10, 2008 (إץåɽưɽ)
#	1.3: Apr. 19, 2009 (®ǥԡ, wpout10)
#	1.4: Sep. 30, 2009 (IBM ServeRAID, ips(4), /dev/ipsd%d)
#	1.5: Dec. 22, 2012 (smartctl)
#	1.6: Feb.  1, 2014 (Ƭ)
#	1.7: Aug.  4, 2015 (FreeBSD 9.3R, camcontrol sanitize)
#	1.8: Nov.  8, 2015 (꡼󥻡С)
#

# 
dmesg="${DMESG:-/var/run/dmesg.boot}"
devices="${DEVICES:-da|ada|ar|aacd|amrd|idad|ipsd|mfid|mlxd|twed}"
#
export LOGFIL="${LOGFIL:-/tmp/wpoutlog.txt}"
export ERRORLOG="${ERRORLOG:-/tmp/wperrlog.txt}"
export DISPUPD="${DISPUPD:-2}"
export STATEFIL="${STATEFIL:-/tmp/status.txt}"

#
export DIALOG="--ascii-lines --no-collapse"

cbs="${CBS:-512}"
obs="${OBS:-1048576}"

resultfil=/tmp/result
nsec=/tmp/sector
stuffs='10'

##sed -n -E "/^(${devices})[0-9][0-9]*:.*</p" $dmesg |
##	sed 's/^\([a-z][a-z]*[0-9][0-9]*\).*/\1/' > $resultfil
sed -n -E "/^(${devices})[0-9][0-9]*:.*B [<(]/p" $dmesg |
	sed 's/^\([a-z][a-z]*[0-9][0-9]*\).*/\1/' > $resultfil

disk=`sed -n '1p' $resultfil`
export TITLE='ϡɥǥõġwipe-out v1.6'
dumpskip=0

echo '# ---------------------------- #' >> $LOGFIL
echo -n "script mainmenu.sh started on " >> $LOGFIL
date >> $LOGFIL

echo '# ---------------------------- #' >> $ERRORLOG
echo -n "script mainmenu.sh started on " >> $ERRORLOG
date >> $ERRORLOG

while true ; do
	dname=`sed -n -E "/^${disk}:.*<.*>/p" $dmesg | sed 's/.*\(<.*>\).*/\1/'`
	bytes=`disksize -B /dev/$disk`
	cap=`disksize -p /dev/$disk`

	msg="                      ᥤ˥塼\n"
	msg="${msg}Υǥ /dev/${disk} ${dname} Ǥ\n"
	msg="${msg}ǥ̤ $bytes Х ($cap) Ǥ\n"
	msg="${msg}ʲΥ˥塼򤷤Ƥ\n"

	echo -n 'displaying main menu' > $STATEFIL

	sh dummyread.sh
	dialog 	2>$resultfil \
		--title "$TITLE" \
		--menu "$msg" \
		20 74 8 \
		z '0񤭤ơΥǥΥǡä' \
		h 'ˡγפɽ' \
		n 'ʣ񤭤ơΥǥΥǡǰ˾ä' \
		m 'ǰõξˡ򤹤' \
		v 'ǡõ줿ǧ (®å)' \
		V 'ǡõ줿ǧ (̾å)' \
		w 'õǥ˽񤭹' \
		L 'ưϿեåԡ˽񤭽Ф' \
		s '̤Υǥ򤹤' \
		d 'ǥΥǡɽ' \
		S 'ǡɽ륻λ' \
		a '֡wipe-out٤ˤĤơפ򸫤' \
		C 'ɽ򥹥꡼󥻡Сڤؤ' \
		D 'ưΥƥåǧ' \
		Y 'ǥ򥳥ԡʹ®Хåå׸' \
		y 'ǥ򥳥ԡ®ǡ١' \
		f '1񤭤ơΥǥΥǡä' \
		p 'ѥ񤭤ơΥǥΥǡä' \
		q 'ѥ񤭤ơΥǥΥǡä' \
		r 'ǡ񤭤ơΥǥΥǡä' \
		P 'ưϿɽ' \
		T 'ǥμʿǾ (SMART) ɽ' \
		Z '˥ǽ (SCSI Sanitize command) ǥǡä' \
		K 'ǥưꤹ' \
		b ' (sh) ư' \
		t ' (csh) ư' \
		M 'CD-ROMmount' \
		U 'CD-ROMumount' \
		B 'MBR *Τ* õ' \
		x 'åȥ󤹤' \
		R 'Ƶư' \
		N '˥塼Ƭ' \
		# end of menu
	case x"$?" in
		x1)
			break
			;;
	esac

	result=`cat $resultfil`

	case x"${result}" in
		x[zfrpq])
			echo -n 'starting erase' > $STATEFIL
			sh erase.sh -$result $disk
			;;
		xh)
			echo -n 'displaying instruction' > $STATEFIL
			dialog	--title 'ˡγ' \
				--textbox help.txt 22 76
			;;
		xs)
			echo -n 'selecting disk' > $STATEFIL
			. seldisk.sh
			;;
		xn)
			echo -n 'starting erase' > $STATEFIL
			sh fine-erase.sh $stuffs $disk
			;;
		xm)
			echo -n 'selecting erase method' > $STATEFIL
			. sel-fine.sh
			;;
		xv)
			echo -n 'starting verify' > $STATEFIL
			sh verify.sh 90 $disk
			;;
		xV)
			echo -n 'starting verify' > $STATEFIL
			sh verify.sh 0 $disk
			;;
		xw)
			echo -n 'writing log' > $STATEFIL
			sh writelog.sh $disk
			;;
		xL)
			echo -n 'saving log' > $STATEFIL
			sh floppylog.sh
			;;
		xd)
			echo -n 'dump sector' > $STATEFIL
			sh dump.sh $dumpskip $disk
			dumpskip=`expr $dumpskip + 1`
			;;
		xS)
			echo -n 'selecting sector' > $STATEFIL
			msg="ꤷƤ ($dumpskip)"
			dialog	2>$nsec \
				--title "$TITLE" \
				--inputbox "$msg" 8 64
			case x"$?" in
			    x0)
				echo '' >> $nsec
				echo "$dumpskip" >> $nsec
				dumpskip=`sed -n '/^[0-9]/p' $nsec | sed -n 1p`
				;;
			esac
			;;
		xa)
			echo -n 'displaying about' > $STATEFIL
			dialog	--title 'wipe-out٤ˤĤ' \
				--textbox info.txt 22 76
			;;
		xC)
			echo -n 'displaying saver' > $STATEFIL
			msg='Alt+F8򲡤ȥ꡼󥻡Сڤؤޤ'
			dialog	--title "$TITLE" \
				--msgbox "$msg" 5 64
			;;
		xD)
			echo -n 'displaying system message' > $STATEFIL
			dialog	--title 'ưΥƥå' \
				--textbox /var/run/dmesg.boot 22 76
			;;
		xy)
			echo -n 'starting copy' > $STATEFIL
			srcdisk=$disk
			. seldisk.sh
			dstdisk=$disk
			sh copy.sh $srcdisk $dstdisk $cbs
			disk=$srcdisk
			;;
		xY)
			echo -n 'starting copy' > $STATEFIL
			srcdisk=$disk
			. seldisk.sh
			dstdisk=$disk
			sh copy.sh $srcdisk $dstdisk $obs
			disk=$srcdisk
			;;
		xP)
			echo -n 'displaying history' > $STATEFIL
			echo "::: $LOGFIL :::" > /tmp/loglog.txt
			cat $LOGFIL >> /tmp/loglog.txt
			echo '' >> /tmp/loglog.txt
			for f in /tmp/erase-log.* ; do
				if [ -f "$f" ]; then
					echo "::: $f :::" >> /tmp/loglog.txt
					cat $f >> /tmp/loglog.txt
					echo '' >> /tmp/loglog.txt
				fi
			done
			for f in /tmp/verify-log.* ; do
				if [ -f "$f" ]; then
					echo "::: $f :::" >> /tmp/loglog.txt
					cat $f >> /tmp/loglog.txt
					echo '' >> /tmp/loglog.txt
				fi
			done
			echo '::: shell variables :::' >> /tmp/loglog.txt
			set >> /tmp/loglog.txt
			echo '' >> /tmp/loglog.txt
			dialog	--title 'ư' \
				--textbox /tmp/loglog.txt 22 76
			;;
		xT)
			echo -n 'displaying smart infomation' > $STATEFIL
			/usr/local/sbin/smartctl -s on /dev/$disk \
				> /tmp/smart.txt 2>&1
			/usr/local/sbin/smartctl -a /dev/$disk \
				>> /tmp/smart.txt 2>&1
			case x"$?" in
			    x0)
				echo "SMARTｪλޤ" \
					> /tmp/smartmsg.txt
				;;
			    *)
				echo "SMARTưޤǤ" \
					> /tmp/smartmsg.txt
				;;
			esac
			echo '' >> $LOGFIL
			echo '::: SMART (smartctl output) :::' >> $LOGFIL
			cat /tmp/smart.txt >> $LOGFIL
			cat /tmp/smart.txt >> /tmp/smartmsg.txt
			dialog	--title 'SMART' \
				--textbox /tmp/smartmsg.txt 22 76
			;;
		xZ)
			echo -n 'starting sanitize' > $STATEFIL
			sh sanitize.sh $disk
			;;
		xK)
			echo -n 'selecting disk (manual)' > $STATEFIL
			msg="ǥꤷƤ ($disk)"
			dialog	2>/tmp/diskname \
				--title "$TITLE" \
				--inputbox "$msg" 8 64
			case x"$?" in
			    x0)
				echo '' >> /tmp/diskname
				echo "$disk" >> /tmp/diskname
				cat /tmp/diskname |	
					sed -n '/^[a-z][a-z]*[0-9][0-9]*/p' |
					sed -n 1p > /tmp/diskname.new
				disk=`cat /tmp/diskname.new`
				;;
			esac
			;;
		xb)
			echo -n 'starting shell' > $STATEFIL
			/bin/sh -i
			;;
		xt)
			echo -n 'starting shell' > $STATEFIL
			if [ -x /bin/csh ]; then
				/bin/csh -i
			else
				msg='cshäCD-ROMޥȤƤ'
				dialog	--title "$TITLE" \
					--msgbox "$msg" 5 64
			fi
			;;
		xM)
			echo -n 'mounting CD-ROM' > $STATEFIL
			if [ -x /cdrom/usr.bin/dialog ]; then
				msg='CD-ROMϤǤ˥ޥȤƤޤ'
			elif mount_cd9660 $CDROM /cdrom > /dev/null 2>&1; then
				msg='CD-ROMޥȤޤ'
			else
				msg='CD-ROMޥȤǤޤǤ'
			fi
			dialog	--title "$TITLE" \
				--msgbox "$msg" 5 64
			;;
		xU)
			echo -n 'unmounting CD-ROM' > $STATEFIL
			msg=''
			if [ ! -x /cdrom/usr.bin/dialog ]; then
				msg='CD-ROMϤǤ˥ޥȤƤޤ'
			fi
			if umount /cdrom > /dev/null 2>&1; then
				msg='CD-ROM򥢥ޥȤޤ'
			elif [ -z "$msg" ]; then
				msg='CD-ROMޥȤǤޤǤ'
			fi
			dialog	--title "$TITLE" \
				--msgbox "$msg" 5 64
			;;
		xB)
			echo -n 'erasing MBR' > $STATEFIL
			sh embr.sh $disk
			;;
		xx)
			echo -n 'starting shutdown' > $STATEFIL
			echo "halt" > /var/run/nologin
			exit 1
			;;
		xR)
			echo -n 'starting reboot' > $STATEFIL
			echo "reboot" > /var/run/nologin
			exit 1
			;;
		#xN)
		#	NOP
		#	;;
	esac
done

dialog	--title "$TITLE" \
	--infobox 'λޤ' 3 48

echo '/bin/sh /wipeout/mainmenu.shפǥ˥塼̤ƤӽФޤ'
echo ''

exit 0

# EOF
